<?php

/**
 **  cas_auth/setup.php
 **
 **  Copyright (c) 2008 Eole (eole@ac-dijon.fr)
 **  Licensed under the GNU GPL. For full terms see the file COPYING.
 **
 **  Authentication through phpCAS
 **
 **/


function squirrelmail_plugin_init_cas_auth() {
    global $squirrelmail_plugin_hooks;
    $squirrelmail_plugin_hooks['login_cookie']['cas_auth'] = 'cas_auth_get_pt';
    $squirrelmail_plugin_hooks['logout']['cas_auth'] = 'cas_auth_logout';
}


function cas_auth_get_pt () {

    /* get globals we me need */
    sqGetGlobalVar('login_username', $login_username);
    sqGetGlobalVar('secretkey', $secretkey);

    include(SM_PATH . 'plugins/cas_auth/config.php');
    include_once('CAS/CAS.php');

    session_start();

    //$USER=null;
    //$CREDENTIAL=null;
    $USER='';
    $CREDENTIAL='';
    $err='';
    $msg='';
    $auth=false;

    phpCAS::setDebug('/tmp/phpCAS.log');

    $CAS = new CASClient(CAS_VERSION_2_0,TRUE,$cas_hostname,$cas_port,$cas_uri);// CAS object in proxy mode
    $auth = $CAS->isAuthenticated();

    if ( ! $auth )  {
        if ( ! $gateway)  {
            $CAS->forceAuthentication();                            // force the authentification if not authenticated
        }
        else
        {
            if (! isset($_GET['ticket']))
            {
                $CAS->checkAuthentication();
            }
        }
    }
    if ($auth) {
        // procedure to obtain a PGT
        if( ! empty($_GET['ticket']) ||          // si on recoit le ticket pour le valider
            ! empty($_GET['pgtIou'])) {           // si on recoit le PGT

            if( ! empty($_SESSION['PGT'])) {
                session_unset(); // delete the CAS session
                $_GET['ticket']=''; // delete the ticket
            }
            if($CAS->hasPGT()) {
                $PGT=$CAS->getPGT();                                           // get the PGT
                $_SESSION['PGT']=$PGT;                                         // met le PGT EN SESSION
            }
        }

        // procedure to obtain or reobtain a PT

        if($CAS->hasPGT()) {                                                    // if there is a PGT
          $PT = $CAS->retrievePT($imap_service,$err_code,$output);             // on récupère un PT
          $_SESSION['PT']=$PT;                                                 // met le PT EN SESSION
          $USER=$CAS->getUser();                                               // recupere le login utilisateur
          $CREDENTIAL=$_SESSION['PT'];
        }

        $_SESSION['login_username'] = $USER;
        $_SESSION['secretkey'] = $CREDENTIAL;

        phpCAS::log('CAS complete : '.$USER.' '.$CREDENTIAL);

        if( ! empty($USER) &&
            ! empty($CREDENTIAL)) {
            header('Location: redirect.php');
        }
    }

}

function cas_auth_logout () {

    include(SM_PATH . 'plugins/cas_auth/config.php');
    include_once('CAS/CAS.php');
    $base_uri = sqm_baseuri();

    $CAS = new CASClient(CAS_VERSION_2_0,TRUE,$cas_hostname,$cas_port,$cas_uri);// CAS object in proxy mode
    // test if already authenticated (application session)
    if ($CAS->isAuthenticated()) {
        // Logout on CAS server, and come back on logout url
        $CAS->logout('https://'.$_SERVER['HTTP_HOST'].$base_uri.'src/signout.php');
    }
}
